' Small script to remove tags from srt subtitles files and to create an ass version
' Author : Vincent aka Lama
' Modified by Dapitch666, adjusted for the Lords of Kobol by Bbsiocnarf and acheved by Golgi =)
'
' To use this script, simply drag and drop the files onto
' the icon of the script. You can also do it from the command line
' by typing cscript Notag_and_Ass_generator.vbs <files>
' Of course this does only work in Windows (98 & later).
'
' Unless there is an error, there is no output!
'
' I'm in no way an expert in VBScript programming (it's pretty obvious
' from the programming style) and I don't want to be ;-).
' This script is provided in the hope that it will be helpful to some,
' and comes with no warranty (backuping your data first is the way to go).

' Modification by Nathbot : 
' - Process multiple files
' - Name ASS file without the "TAG" string 


' ZIP stuff

Function Zip(sFile,sArchiveName)
  'This script is provided under the Creative Commons license located
  'at http://creativecommons.org/licenses/by-nc/2.5/ . It may not
  'be used for commercial purposes with out the expressed written consent
  'of NateRice.com

  Set oFSO = WScript.CreateObject("Scripting.FileSystemObject")
  Set oShell = WScript.CreateObject("Wscript.Shell")

  '--------Find Working Directory--------
  aScriptFilename = Split(Wscript.ScriptFullName, "\")
  sScriptFilename = aScriptFileName(Ubound(aScriptFilename))
  sWorkingDirectory = Replace(Wscript.ScriptFullName, sScriptFilename, "")
  '--------------------------------------

  '-------Ensure we can find 7za.exe------
  If oFSO.FileExists(sWorkingDirectory & "\" & "7z.exe") Then
    s7zLocation = ""
  ElseIf oFSO.FileExists("C:\Program Files\7-Zip\7z.exe") Then
    s7zLocation = "C:\Program Files\7-Zip\"
  Else
    Zip = "Error: Couldn't find 7z.exe"
    Exit Function
  End If
  '--------------------------------------
	commandLine = """" & s7zLocation & "7z.exe"" a -tzip -y """ & sArchiveName & """ " & sFile
	'MsgBox(commandLine)
  oShell.Run commandLine, 0, True   

  If oFSO.FileExists(sArchiveName) Then
    Zip = 1
  Else
    Zip = "Error: Archive Creation Failed."
  End If
End Function
' End ZIP stuff



Dim Extensions        ' Extensions of the files to be processed
Dim FilesToProcess()  ' Files to be processed
Dim PatternsASS
Dim PatternsNoTag

' File Name
PatternsFileNameDot = Array(Array(".Tag", ""), Array(".TAG", ""), Array(".tag",""))
PatternsFileNameDash = Array(Array("-Tag", ""), Array("-TAG", ""), Array("-tag",""))

' For NoTag
PatternsNoTag = Array(Array("{.*?}", ""), Array("", "oe"), Array("", "ae"), Array("", "Oe"), Array("", "Ae"), Array("<u>", ""), Array("<b>", ""), Array("</u>", ""), Array("</b>", ""))

' For ASS
PatternsASS = Array(Array("<i>", "{\i1}"), Array("</i>", "{\i0}"), Array("<u>","{\u1}"), Array("</u>","{\u0}"), Array("<b>","{\b1}"), Array("</b>","{\b0}"))


' Here we only process TAG .srt files
Extensions=".srt"

Set objArgs = WScript.Arguments

i = 0
j = 0

Set objRE = New RegExp
objRE.IgnoreCase = True
objRE.Pattern = Extensions

Set reTags = New RegExp
reTags.Global  = True

' See what file we need to process
ReDim FilesToProcess(WScript.Arguments.Count - 1)
Do While i <= WScript.Arguments.Count - 1
    arg = WScript.Arguments.Item(i)

    Set Matches = objRE.Execute(arg)

    For Each Match In Matches
        If Match.firstIndex > 0 Then
            FilesToProcess(j) = arg
            j = j + 1
        End If
    Next

    i = i+ 1
Loop

' Open each file and process it
For Each file in FilesToProcess
    If StrComp(file, "") <> 0 Then
		
        fileName = objRE.Replace(file, "")
		
		zipPath = fileName & ".zip"
		
		fileNameTAG = fileName & ".srt"

        'Input Files
        Set objInputFSO   = CreateObject("Scripting.FileSystemObject")
        Set objInputFile  = objInputFSO.OpenTextFile(fileNameTAG)

		'Out Files
        Set objOutputFSO  = CreateObject("Scripting.FileSystemObject")
		
		'FileName operations for NoTAG version
		'<--
		If InStr(1, fileName, "tag", vbTextCompare) <> 0 Then
			If InStr(1, fileName, ".tag", vbTextCompare) <> 0 Then
				For Each Pattern In PatternsFileNameDot
					reTags.Pattern = Pattern(0)
					fileName = reTags.Replace(fileName, Pattern(1))
				Next
				fileNameNoTAG = fileName & ".NoTAG.srt"
			Elseif InStr(1, fileName, "-tag", vbTextCompare) <> 0 Then
				For Each Pattern In PatternsFileNameDash
					reTags.Pattern = Pattern(0)
					fileName = reTags.Replace(fileName, Pattern(1))
				Next
				fileNameNoTAG = fileName & "-NoTAG.srt"
			End If
		Else
			fileNameNoTAG = fileName & ".NoTAG.srt"
		End If
		Set objOutputFileNoTag = objOutputFSO.CreateTextFile(fileNameNoTAG)
		'-->
		
		'Note from nathbot: To include the "TAG" mention in the ASS filename, uncomment the next line and comment the whole part titled "FileName operations for ASS version"
        'Set fileNameASS = fileName & ".ass"
		
		'FileName operations for ASS version
		'<--
        Set objInputFile  = objInputFSO.OpenTextFile(fileNameTAG)
		If InStr(1, fileName, "tag", vbTextCompare) <> 0 Then
			If InStr(1, fileName, ".tag", vbTextCompare) <> 0 Then
				For Each Pattern In PatternsFileNameDot
					reTags.Pattern = Pattern(0)
					fileName = reTags.Replace(fileName, Pattern(1))
				Next
				fileNameASS = fileName & ".ass"
			Elseif InStr(1, fileName, "-tag", vbTextCompare) <> 0 Then
				For Each Pattern In PatternsFileNameDash
					reTags.Pattern = Pattern(0)
					fileName = reTags.Replace(fileName, Pattern(1))
				Next
				fileNameASS = fileName & ".ass"
			End If
		Else
			fileNameASS = fileName & ".ass"
		End If
		'-->
		
		Set objOutputFileASS = objOutputFSO.CreateTextFile(fileNameASS)

		'ASS header
		objOutputFileASS.WriteLine("[Script Info]")
		objOutputFileASS.WriteLine("Title: <untitled>")
		objOutputFileASS.WriteLine("Original Script: <unknown>")
		objOutputFileASS.WriteLine("ScriptType: v4.00+")
		objOutputFileASS.WriteLine("PlayResX: 384")
		objOutputFileASS.WriteLine("PlayResY: 288")
		objOutputFileASS.WriteLine("PlayDepth: 0")
		objOutputFileASS.WriteLine("Timer: 100.0")
		objOutputFileASS.WriteLine("WrapStyle: 0")
		objOutputFileASS.WriteLine("")
		objOutputFileASS.WriteLine("[v4+ Styles]")
		objOutputFileASS.WriteLine("Format: Name, Fontname, Fontsize, PrimaryColour, SecondaryColour, OutlineColour, BackColour, Bold, Italic,  Underline, StrikeOut, ScaleX, ScaleY, Spacing, Angle, BorderStyle, Outline, Shadow, Alignment, MarginL, MarginR, MarginV, Encoding")
		objOutputFileASS.WriteLine("Style: Default,Arial,20,&H00FFFFFF,&H00000000,&H00000000,&H00000000,0,0,0,0,100,100,0,0,1,2,0,2,15,15,15,0")
		objOutputFileASS.WriteLine("")
		objOutputFileASS.WriteLine("[Events]")
		objOutputFileASS.WriteLine("Format: Layer, Start, End, Style, Name, MarginL, MarginR, MarginV, Effect, Text")
		
		content = objInputFile.ReadAll
		line = Split(content, vbCrLf & vbCrLf)
		fin = UBound(line)-1
		
		For cpt = 0 To fin
			'ASS lines
			sublines = Split(line(cpt), vbCrLf)
			taille = UBound(sublines)
			timings = Split(sublines(1), " --> ")
			timings(0) = Mid(timings(0),2,10)
			timings(1) = Mid(timings(1),2,10)
			timings(0) = Replace(timings(0),",",".")
			timings(1) = Replace(timings(1),",",".")
			outputLineASS = "Dialogue: 0," & timings(0) & "," & timings(1) & ",Default,,0000,0000,0000,," & sublines(2)
			For cpt2 = 3 To taille
				outputLineASS = outputLineASS & "\N" & sublines(cpt2)
			Next
			For Each Pattern In PatternsASS
				reTags.Pattern = Pattern(0)
				outputLineASS = reTags.Replace(outputLineASS, Pattern(1))
            Next
			objOutputFileASS.WriteLine(outputLineASS)
			
			'NoTAG.srt lines
			outputLineNoTag = line(cpt)
			For Each Pattern In PatternsNoTag
				reTags.Pattern = Pattern(0)
                outputLineNoTag = reTags.Replace(outputLineNoTag, Pattern(1))
            Next
			objOutputFileNoTag.WriteLine(outputLineNoTag & vbCrLf)
		Next
		
		objOutputFileASS.Close
		objOutputFileNoTag.Close
		objInputFile.Close
		
		objOutputFileListPath = fileName & "_filelist.txt"
		Set objOutputFileList = objOutputFSO.CreateTextFile(objOutputFileListPath)
		objOutputFileList.WriteLine(fileNameASS)
		objOutputFileList.WriteLine(fileNameNoTAG)
		objOutputFileList.WriteLine(fileNameTAG)
		objOutputFileList.Close
		
		'Zip files
		Zip "@""" & objOutputFileListPath & """", zipPath
		
		' Delete temp file
		If objInputFSO.FileExists(objOutputFileListPath) Then 
		objInputFSO.DeleteFile objOutputFileListPath
		End If 
    End If
Next

wscript.quit